function mvf = me(cur, ref, brow, bcol, search);
%ME Motion estimation
% mvf = me(cur, ref, brow, bcol, search);
step=1;
[rows cols]=size(cur);
total = 0;
% Scansione di tutti i macroblocchi
for r=1:brow:rows,
    for c=1:bcol:cols,        
        % Selezione del macroblocco corrente
        B=cur(r:r+brow-1,c:c+bcol-1);
        % Inizializzazioni del vettore e dell'errore
        dcolmin=0; drowmin=0;
        SSDmin=brow*bcol*256*256;
        % Fase di Motion Estimation: individuazione del miglior vettore
        for dcol=-search:step:search,
            for drow=-search:step:search,
                % Check: l'area di ricerca deve essere interna all'immagine
                if ((r+drow>0)&(r+drow+brow-1<=rows)& ...
                        (c+dcol>0)&(c+dcol+bcol-1<=cols))
                    % Macroblocco di confronto
                    R=ref(r+drow:r+drow+brow-1, c+dcol:c+dcol+bcol-1);
                    SSD=sum(sum((B-R).*(B-R)));
                    if (SSD<SSDmin)
                        SSDmin=SSD;
                        dcolmin=dcol;
                        drowmin=drow;
                    end;
                end; % vettore all'interno della frame
            end; % ciclo su drow
        end; % ciclo su dcol
        % Salviamo il MVF
        mvf(r:r+brow-1,c:c+bcol-1,1)=drowmin;
        mvf(r:r+brow-1,c:c+bcol-1,2)=dcolmin;
        total = total + SSDmin;
    end; % ciclo su c
end; % ciclo su r
total = total /rows /cols